SystemOrganization addCategory: #Deli!
SystemOrganization addCategory: #'Deli-models'!
SystemOrganization addCategory: #'Deli-configuration'!
SystemOrganization addCategory: #'Deli-models-tests'!
SystemOrganization addCategory: #'Deli-frontend'!

WAFileLibrary subclass: #DLFileLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLFileLibrary methodsFor: 'as yet unclassified' stamp: 'cr 6/1/2009 01:16'!
selectorsToInclude

	^ Array with: 'styleCss'! !

!DLFileLibrary methodsFor: 'uploaded' stamp: 'cr 6/1/2009 01:25'!
styleCss
	^
'.menu {
	float: left;
	width: 250px;
	padding: 10px;
}

thead>td {
	font-weight: bold;
}
'! !

!DLFileLibrary methodsFor: 'as yet unclassified' stamp: 'cr 6/1/2009 01:14'!
updateRoot:	anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot stylesheet url: DLFileLibrary / #styleCss.! !

Object subclass: #DLLoginUser
	instanceVariableNames: 'userName password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

DLLoginUser class
	instanceVariableNames: 'userName password'!

DLLoginUser class
	instanceVariableNames: 'userName password'!

!DLLoginUser class methodsFor: 'as yet unclassified' stamp: 'Marik 6/2/2009 16:52'!
descriptionPassword
	^ (MAPasswordDescription auto: 'password' label: 'Passwort' priority:20)
			beRequired;
			yourself.! !

!DLLoginUser class methodsFor: 'as yet unclassified' stamp: 'Marik 6/2/2009 15:26'!
descriptionUserName
	^ (MAStringDescription auto: 'userName' label: 'Name' priority:10)
			beRequired;
			yourself.! !

!DLLoginUser class methodsFor: 'accessing-generated' stamp: 'Marik 6/2/2009 15:28'!
password
	^ password! !

!DLLoginUser class methodsFor: 'accessing-generated' stamp: 'Marik 6/2/2009 15:49'!
password: anObject
	password := anObject! !

!DLLoginUser class methodsFor: 'accessing-generated' stamp: 'Marik 6/2/2009 15:27'!
userName
	^ userName! !

!DLLoginUser class methodsFor: 'accessing-generated' stamp: 'Marik 6/2/2009 15:49'!
userName: anObject
	userName := anObject! !

!DLLoginUser methodsFor: 'accessing' stamp: 'sebh 6/6/2009 15:58'!
acceptUser

	|user|
	user := DLUser getOrCreateUserName: self userName email: userName, '@student.hpi.uni-potsdam.de'.
	self 	clearUserData.
	^ user.! !

!DLLoginUser methodsFor: 'accessing' stamp: 'Marik 6/2/2009 16:16'!
clearUserData

	self 	userName: nil;
			password: nil! !

!DLLoginUser methodsFor: 'accessing' stamp: 'sebh 6/6/2009 16:19'!
denyUser

	self clearUserData.
	^ nil! !

!DLLoginUser methodsFor: 'accessing-generated' stamp: 'sebh 5/27/2009 12:03'!
password
	^ password! !

!DLLoginUser methodsFor: 'accessing' stamp: 'Marik 6/2/2009 16:00'!
password: anObject

	password := anObject.! !

!DLLoginUser methodsFor: 'accessing-generated' stamp: 'sebh 5/27/2009 12:03'!
userName
	^ userName! !

!DLLoginUser methodsFor: 'accessing' stamp: 'Marik 6/2/2009 16:00'!
userName: anObject

	userName := anObject.! !

!DLLoginUser methodsFor: 'accessing' stamp: 'Marik 6/2/2009 16:37'!
validateLogin

	|loginChecker|
	
	"A test user so we don't need to have hpi nads2 present all the time"
	(self userName = 'john' and: [self password = 'john']) | (self userName = 'jack' and: [self password = 'jack'])
		ifTrue: [^self acceptUser].
	"A bad test user"
	self userName =  'christian'
		ifTrue: [^self denyUser].
	
	loginChecker := HPILoginChecker new.
	(loginChecker checkLogin: self userName password: self password)
		ifTrue:[^self acceptUser]
		ifFalse:[^self denyUser]! !

Object subclass: #DLModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

DLModel subclass: #DLDeadline
	instanceVariableNames: 'deadlineName deadlineDescription lecture date time'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLDeadline class methodsFor: 'as yet unclassified' stamp: 'sebh 6/4/2009 12:30'!
descriptionDate
	^ (MADateDescription auto: 'date' label: 'Datum' priority: 40)
			beRequired;
			yourself.
! !

!DLDeadline class methodsFor: 'as yet unclassified' stamp: 'sebh 6/3/2009 22:01'!
descriptionDeadlineDescription
	^ (MAMemoDescription auto:'deadlineDescription' label: 'Beschreibung' priority: 30) 
		beRequired;
		yourself.! !

!DLDeadline class methodsFor: 'as yet unclassified' stamp: 'sebh 6/3/2009 22:01'!
descriptionDeadlineName
	^ (MAStringDescription auto: 'deadlineName' label: 'Titel' priority: 20)
			beRequired;
			yourself.
! !

!DLDeadline class methodsFor: 'as yet unclassified' stamp: 'sebh 6/3/2009 22:01'!
descriptionLecture
	^ (MASingleOptionDescription auto: 'lecture' label: 'Vorlesung' priority: 10)
			optionsAndLabels: (DLLecture getKeyValueSelect: [:aLecture | ]);
			beRequired;
			yourself.
! !

!DLDeadline class methodsFor: 'as yet unclassified' stamp: 'sebh 6/4/2009 12:30'!
descriptionTime
	^ (MATimeDescription auto: 'time' label: 'Uhrzeit' priority: 50)
			beRequired;
			yourself.
! !

!DLDeadline class methodsFor: 'persistence-description' stamp: ''!
sqsDescrDate
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'date';
		 sqlType: #date;
		 objectClass: #Date;
		 tableName: 'dl_deadlines';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'date';
		 yourself! !

!DLDeadline class methodsFor: 'persistence-description' stamp: ''!
sqsDescrDeadlineDescription
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'deadline_description';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_deadlines';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'deadlineDescription';
		 yourself! !

!DLDeadline class methodsFor: 'persistence-description' stamp: ''!
sqsDescrDeadlineName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'deadline_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_deadlines';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'deadlineName';
		 yourself! !

!DLDeadline class methodsFor: 'persistence-description' stamp: ''!
sqsDescrLecture
	^ SqsColumn new associatedClass: #DLLecture;
		 manuallyMaintained: false;
		 columnName: 'lecture_id';
		 sqlType: #integer;
		 objectClass: #DLLecture;
		 tableName: 'dl_deadlines';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'lecture';
		 yourself! !

!DLDeadline class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTime
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'time';
		 sqlType: #time;
		 objectClass: #Time;
		 tableName: 'dl_deadlines';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'time';
		 yourself! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 5/20/2009 20:55'!
date

	^ date! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 5/20/2009 20:55'!
date: anObject

	date := anObject.! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/3/2009 20:57'!
deadlineDescription

	^ deadlineDescription! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/3/2009 20:57'!
deadlineDescription: anObject

	deadlineDescription := anObject.! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 5/20/2009 20:55'!
deadlineName

	^ deadlineName! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 5/20/2009 20:55'!
deadlineName: anObject

	deadlineName := anObject.! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/4/2009 14:12'!
descriptionList
 ^ super description select: [:each | #(deadlineDescription deadlineName date time) includes: each accessor selector]! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/4/2009 22:47'!
descriptionUpdate
	^ self descriptionList! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/3/2009 22:03'!
lecture

	^ lecture! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/3/2009 22:03'!
lecture: anObject

	lecture := anObject.! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:32'!
time

	^ time! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:32'!
time: anObject

	time := anObject.! !

DLModel subclass: #DLGroup
	instanceVariableNames: 'groupName groupDescription lecture users'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLGroup class methodsFor: 'persistence-description' stamp: ''!
sqsDescrDescription
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'description';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_groups';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'description';
		 yourself! !

!DLGroup class methodsFor: 'persistence-description' stamp: ''!
sqsDescrGroupDescription
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'group_description';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_groups';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'groupDescription';
		 yourself! !

!DLGroup class methodsFor: 'persistence-description' stamp: ''!
sqsDescrGroupName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'group_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_groups';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'groupName';
		 yourself! !

!DLGroup class methodsFor: 'persistence-description' stamp: ''!
sqsDescrLecture
	^ SqsColumn new associatedClass: #DLLecture;
		 manuallyMaintained: false;
		 columnName: 'lecture_id';
		 sqlType: #integer;
		 objectClass: #DLLecture;
		 tableName: 'dl_groups';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'lecture';
		 yourself! !

!DLGroup class methodsFor: 'persistence-description' stamp: ''!
sqsDescrUsers
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #OrderedCollection;
		 tableName: 'dl_groups_users';
		 ownerColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'dl_group_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_groups';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'dl_group_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'users_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_users';
				 updateActions: #();
				 deleteActions: #(#CASCADE );
				 referencingColumns: (Set new add: 'users_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSREF;
			 yourself);
		 maintainOrder: true;
		 simpleValues: false;
		 indexType: #integer;
		 referencedClass: #DLUser;
		 linkedVariable: 'users';
		 orderField: 'sqs_order_number';
		 yourself! !

!DLGroup methodsFor: 'accessing' stamp: 'sebh 5/27/2009 16:27'!
groupDescription

	^ groupDescription! !

!DLGroup methodsFor: 'accessing' stamp: 'sebh 5/27/2009 16:27'!
groupDescription: anObject

	groupDescription := anObject.! !

!DLGroup methodsFor: 'accessing' stamp: 'sebh 5/20/2009 20:54'!
groupName

	^ groupName! !

!DLGroup methodsFor: 'accessing' stamp: 'sebh 5/20/2009 20:54'!
groupName: anObject

	groupName := anObject.! !

!DLGroup methodsFor: 'accessing' stamp: 'sebh 5/26/2009 12:00'!
initialize
	super initialize.
	self users: OrderedCollection new.! !

!DLGroup methodsFor: 'accessing' stamp: 'sebh 5/26/2009 11:19'!
lecture

	^ lecture! !

!DLGroup methodsFor: 'accessing' stamp: 'sebh 5/26/2009 11:19'!
lecture: anObject

	lecture := anObject.! !

!DLGroup methodsFor: 'accessing' stamp: 'sebh 5/26/2009 11:19'!
users

	^ users! !

!DLGroup methodsFor: 'accessing' stamp: 'sebh 5/26/2009 11:19'!
users: anObject

	users := anObject.! !

DLModel subclass: #DLLecture
	instanceVariableNames: 'lectureName lectureDescription semester teacher assistants students visible groupSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLLecture class methodsFor: 'as yet unclassified' stamp: 'Marik 5/27/2009 15:42'!
createLectureName: aLectureName semester: aSemester description: aDescription
	^ self new
		lectureName: aLectureName;
		semester: aSemester;
		description: aDescription;
		save;
		yourself.! !

!DLLecture class methodsFor: 'as yet unclassified' stamp: 'sebh 6/3/2009 20:36'!
descriptionAssistants
	^ (MAMultipleOptionDescription auto: 'assistants' label: 'Assistenten' priority: 40)
		 	optionsAndLabels: (DLUser getKeyValueSelect: [:aUser | ]);
			yourself.
! !

!DLLecture class methodsFor: 'as yet unclassified' stamp: 'cr 5/31/2009 16:01'!
descriptionGroupSize
	^ (MANumberDescription auto: 'groupSize' label: 'Gruppengre' priority: 60)
			yourself.
! !

!DLLecture class methodsFor: 'as yet unclassified' stamp: 'cr 5/31/2009 16:01'!
descriptionLectureDescription
	^ (MAMemoDescription auto: 'lectureDescription' label: 'Beschreibung' priority: 20)
			yourself.
! !

!DLLecture class methodsFor: 'as yet unclassified' stamp: 'cr 5/31/2009 16:01'!
descriptionLectureName
	^ (MAStringDescription auto: 'lectureName' label: 'Lehrveranstaltung' priority: 10)
			beRequired;
			yourself.
! !

!DLLecture class methodsFor: 'as yet unclassified' stamp: 'sebh 6/3/2009 19:30'!
descriptionSemester
	^ (MASingleOptionDescription auto: 'semester' label: 'Semester' priority: 50)
			optionsAndLabels: (DLSemester getKeyValueSelect: [:aSemester | aSemester year > 2008]);
			beRequired;
			reference: MAStringDescription new;
			yourself.! !

!DLLecture class methodsFor: 'as yet unclassified' stamp: 'cr 6/6/2009 15:58'!
descriptionStudents
	^ (MAMultipleOptionDescription auto: 'students' label: 'Studenten' priority: 60)
		 	optionsAndLabels: (DLUser getKeyValueSelect: [:aUser | ]);
			yourself.
! !

!DLLecture class methodsFor: 'as yet unclassified' stamp: 'sebh 6/3/2009 20:36'!
descriptionTeacher

	^ (MASingleOptionDescription auto: 'teacher' label: 'Dozent' priority: 10)
		optionsAndLabels: (DLUser getKeyValueSelect: [:aUser | ]);
		yourself.
! !

!DLLecture class methodsFor: 'as yet unclassified' stamp: 'sebh 6/4/2009 12:20'!
descriptionVisible
	^ (MABooleanDescription auto: 'visible' label: 'Sichtbar' priority: 70)
			default: true;
			yourself.
! !

!DLLecture class methodsFor: 'as yet unclassified' stamp: 'Marik 5/27/2009 15:47'!
getOrCreateUserName: aLectureName semester: aSemester description: aDescription

	| lecture |
	lecture := (SqsSearch for: self) detect: [:aLecture | 
		(aLecture lectureName = aLectureName) & (aLecture semester = aSemester)]
	                                 ifNone: [nil].
	lecture ifNotNil: [ ^ lecture ].
	^ self createLectureName: aLectureName semester: aSemester description: aDescription.
! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrAssistants
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #OrderedCollection;
		 tableName: 'dl_lectures_assistants';
		 ownerColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'dl_lecture_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_lectures';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'dl_lecture_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'assistants_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_users';
				 updateActions: #();
				 deleteActions: #(#CASCADE );
				 referencingColumns: (Set new add: 'assistants_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSREF;
			 yourself);
		 maintainOrder: true;
		 simpleValues: false;
		 indexType: #integer;
		 referencedClass: #DLUser;
		 linkedVariable: 'assistants';
		 orderField: 'sqs_order_number';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrGroupSize
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'group_size';
		 sqlType: #integer;
		 objectClass: #SmallInteger;
		 tableName: 'dl_lectures';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'groupSize';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrLectureDescription
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'lecture_description';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_lectures';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'lectureDescription';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrLectureName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'lecture_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_lectures';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'lectureName';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrSemester
	^ SqsColumn new associatedClass: #DLSemester;
		 manuallyMaintained: false;
		 columnName: 'semester_id';
		 sqlType: #integer;
		 objectClass: #DLSemester;
		 tableName: 'dl_lectures';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'semester';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrStudents
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #Set;
		 tableName: 'dl_lectures_students';
		 ownerColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'dl_lecture_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_lectures';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'dl_lecture_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'students_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_users';
				 updateActions: #();
				 deleteActions: #(#CASCADE );
				 referencingColumns: (Set new add: 'students_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSREF;
			 yourself);
		 maintainOrder: false;
		 simpleValues: false;
		 indexType: #integer;
		 referencedClass: #DLUser;
		 linkedVariable: 'students';
		 orderField: 'sqs_order_number';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTeacher
	^ SqsColumn new associatedClass: #DLUser;
		 manuallyMaintained: false;
		 columnName: 'teacher_id';
		 sqlType: #integer;
		 objectClass: #DLUser;
		 tableName: 'dl_lectures';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'teacher';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrVisible
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'visible';
		 sqlType: #boolean;
		 objectClass: #True;
		 tableName: 'dl_lectures';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'visible';
		 yourself! !

!DLLecture methodsFor: 'accessing' stamp: 'cr 6/6/2009 16:24'!
addStudent: aUser
	"(self students contains: aUser) ifFalse: [
		self students add: aUser.
		self save.
	].
"self break.
	(SqsSearch for: self class) detect: [:aLecture | 
		(aLecture students contains: aUser) & (aLecture = self)]
	ifNone: [
		self students add: aUser.
		self save.
	].! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/3/2009 18:08'!
assistants

	^ assistants! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/3/2009 18:08'!
assistants: anObject

	assistants := anObject.! !

!DLLecture methodsFor: 'as yet unclassified' stamp: 'sebh 6/3/2009 19:13'!
canonicalName
	^ self lectureName, ' ', self semester canonicalName! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/3/2009 20:54'!
descriptionList
 ^ super description select: [:each | #(lectureName lectureDescription teacher assistants semester) includes: each accessor selector]! !

!DLLecture methodsFor: 'accessing' stamp: 'cr 5/31/2009 16:02'!
groupSize

	^ groupSize! !

!DLLecture methodsFor: 'accessing' stamp: 'cr 5/31/2009 16:02'!
groupSize: anObject

	groupSize := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'cr 6/6/2009 15:56'!
initialize
	super initialize.
	self assistants: OrderedCollection new;
		students: OrderedCollection new.! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 5/27/2009 16:23'!
lectureDescription

	^ lectureDescription! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 5/27/2009 16:23'!
lectureDescription: anObject

	lectureDescription := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 5/20/2009 16:23'!
lectureName

	^ lectureName! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 5/20/2009 16:23'!
lectureName: anObject

	lectureName := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 5/20/2009 16:23'!
semester

	^ semester! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 5/20/2009 16:23'!
semester: anObject

	semester := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:18'!
students

	^ students! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:18'!
students: anObject

	students := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/3/2009 18:08'!
teacher

	^ teacher! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/3/2009 18:08'!
teacher: anObject

	teacher := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:18'!
visible

	^ visible! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:18'!
visible: anObject

	visible := anObject.! !

!DLModel class methodsFor: 'as yet unclassified' stamp: 'sebh 5/28/2009 14:46'!
createFrom: anArray
	"Create an object with the values given in anArray and use the standard getters/setters so nondefault get/set behaviour works"
	| newobject |
	newobject := self new.
	anArray do: [:element | newobject perform: (element key, ':') asSymbol withArguments: (Array with: element value) ].
	newobject save.
	^ newobject
	! !

!DLModel class methodsFor: 'as yet unclassified' stamp: 'sebh 6/3/2009 19:11'!
getKeyValueSelect: aBlock
	| objects kv |
	objects := (SqsSearch for: self) select: aBlock.
	kv := OrderedCollection new.
	objects do: [:object | kv add: (object -> object canonicalName)].
	^ kv
! !

!DLModel class methodsFor: 'as yet unclassified' stamp: 'sebh 5/28/2009 14:44'!
getOrCreateFrom: anAttributeArray
	"Get an object from a given attribute array, create one if it doesn't exist yet.'"
	| objects keys values |
	keys := anAttributeArray collect: [:anAttribute | anAttribute key].
	values := anAttributeArray collect: [:anAttribute | anAttribute value].
	objects := (SqsSearch for: self) searchBy: keys withValues: values limit:2.
	
	objects size > 1
	ifTrue: [ ^ nil "TODO: Replace this with an exception stating that there is more than one object"].
	objects size = 1
	ifTrue: [ ^ objects at: 1 ]
	ifFalse:[ ^ self createFrom: anAttributeArray ].! !

!DLModel class methodsFor: 'as yet unclassified' stamp: 'sebh 5/28/2009 10:24'!
sqsAbstractBaseClass! !

!DLModel methodsFor: 'as yet unclassified' stamp: 'sebh 6/3/2009 19:09'!
canonicalName
	self subclassResponsibility! !

!DLModel methodsFor: 'as yet unclassified' stamp: 'sebh 6/3/2009 19:44'!
descriptionList
	^ self description! !

!DLModel methodsFor: 'as yet unclassified' stamp: 'sebh 6/4/2009 22:47'!
descriptionUpdate
	^ self description! !

!DLModel methodsFor: 'as yet unclassified' stamp: 'sebh 6/3/2009 20:53'!
printString
	^ self canonicalName! !

DLModel subclass: #DLSemester
	instanceVariableNames: 'semesterName year'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLSemester class methodsFor: 'persistence-description' stamp: ''!
sqsDescrSemesterName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'semester_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_semesters';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'semesterName';
		 yourself! !

!DLSemester class methodsFor: 'persistence-description' stamp: ''!
sqsDescrYear
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'year';
		 sqlType: #integer;
		 objectClass: #SmallInteger;
		 tableName: 'dl_semesters';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'year';
		 yourself! !

!DLSemester methodsFor: 'accessing' stamp: 'sebh 6/3/2009 19:13'!
canonicalName
	^ self semesterName, ' ', self year asString.! !

!DLSemester methodsFor: 'accessing' stamp: 'sebh 5/20/2009 15:46'!
semesterName

	^ semesterName! !

!DLSemester methodsFor: 'accessing' stamp: 'sebh 5/20/2009 15:46'!
semesterName: anObject

	semesterName := anObject.! !

!DLSemester methodsFor: 'accessing' stamp: 'sebh 5/20/2009 15:46'!
year

	^ year! !

!DLSemester methodsFor: 'accessing' stamp: 'sebh 5/20/2009 15:46'!
year: anObject

	year := anObject.! !

DLModel subclass: #DLUser
	instanceVariableNames: 'userName realName email isAdmin isTeacher isAssistant'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLUser class methodsFor: 'as yet unclassified' stamp: 'sebh 5/27/2009 13:30'!
createUserName: aUserName email: aEmail
	^ self new
		userName: aUserName;
		email: aEmail;
		save;
		yourself.! !

!DLUser class methodsFor: 'persistence-description' stamp: 'sebh 6/4/2009 12:42'!
descriptionIsAdmin
	^ (MABooleanDescription auto: 'isTeacher' label: 'Administrator' priority: 30)
			default: false;
			yourself.
! !

!DLUser class methodsFor: 'persistence-description' stamp: 'sebh 6/4/2009 12:44'!
descriptionIsAssistant
	^ (MABooleanDescription auto: 'isAssistant' label: 'Assistant' priority: 40)
			default: false;
			yourself.
! !

!DLUser class methodsFor: 'persistence-description' stamp: 'sebh 6/4/2009 12:42'!
descriptionIsTeacher
	^ (MABooleanDescription auto: 'isTeacher' label: 'Dozent' priority: 40)
			default: false;
			yourself.
! !

!DLUser class methodsFor: 'persistence-description' stamp: 'sebh 6/4/2009 13:51'!
descriptionRealName
		^ (MAStringDescription auto: 'realName' label: 'Name' priority: 20)
			beRequired;
			yourself.
		
! !

!DLUser class methodsFor: 'persistence-description' stamp: 'sebh 6/4/2009 12:47'!
descriptionUserName
		^ (MAStringDescription auto: 'userName' label: 'Benutzername' priority: 10)
			beRequired;
			readonly: true;
			yourself.
		
! !

!DLUser class methodsFor: 'persistence-description' stamp: 'sebh 6/4/2009 12:41'!
descriptionVisible
	^ (MABooleanDescription auto: 'isTeacher' label: 'Dozent' priority: 30)
			default: true;
			yourself.
! !

!DLUser class methodsFor: 'as yet unclassified' stamp: 'sebh 5/27/2009 13:56'!
getOrCreateUserName: aUserName email: aEmail
	| user |
	user := (SqsSearch for: self) detect: [:aUser | (aUser userName = aUserName)] ifNone: [nil].
	user ifNotNil: [ ^ user ].
	^ self createUserName: aUserName email: aEmail.
! !

!DLUser class methodsFor: 'persistence-description' stamp: 'Marik 5/27/2009 10:23'!
sqsDescrEmail
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'email';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_users';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'email';
		 yourself! !

!DLUser class methodsFor: 'persistence-description' stamp: ''!
sqsDescrIsAdmin
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'is_admin';
		 sqlType: #boolean;
		 objectClass: #False;
		 tableName: 'dl_users';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'isAdmin';
		 yourself! !

!DLUser class methodsFor: 'persistence-description' stamp: ''!
sqsDescrIsAssistant
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'is_assistant';
		 sqlType: #boolean;
		 objectClass: #True;
		 tableName: 'dl_users';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'isAssistant';
		 yourself! !

!DLUser class methodsFor: 'persistence-description' stamp: ''!
sqsDescrIsTeacher
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'is_teacher';
		 sqlType: #boolean;
		 objectClass: #True;
		 tableName: 'dl_users';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'isTeacher';
		 yourself! !

!DLUser class methodsFor: 'persistence-description' stamp: ''!
sqsDescrRealName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'real_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_users';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'realName';
		 yourself! !

!DLUser class methodsFor: 'persistence-description' stamp: 'Marik 5/27/2009 10:24'!
sqsDescrUserName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'user_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_users';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'userName';
		 yourself! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/3/2009 19:13'!
canonicalName
	^ self userName, ' <', self email, '>'! !

!DLUser methodsFor: 'accessing' stamp: 'Marik 5/27/2009 10:17'!
email

	^ email! !

!DLUser methodsFor: 'accessing' stamp: 'Marik 5/27/2009 10:17'!
email: anObject

	email := anObject.! !

!DLUser methodsFor: 'initialize-release' stamp: 'sebh 6/3/2009 19:23'!
initialize
	super initialize.
	self isAdmin: false.! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/3/2009 17:34'!
isAdmin
	^ isAdmin! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 5/27/2009 23:08'!
isAdmin: anObject

	isAdmin := anObject.! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:36'!
isAssistant

	^ isAssistant! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:36'!
isAssistant: anObject

	isAssistant := anObject.! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:35'!
isTeacher

	^ isTeacher! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:35'!
isTeacher: anObject

	isTeacher := anObject.! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:37'!
realName

	^ realName! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:37'!
realName: anObject

	realName := anObject.! !

!DLUser methodsFor: 'accessing' stamp: 'Marik 5/26/2009 13:25'!
userName

	^ userName! !

!DLUser methodsFor: 'accessing' stamp: 'Marik 5/26/2009 13:25'!
userName: anObject

	userName := anObject.! !

!DLUser methodsFor: 'accessing' stamp: 'cr 6/6/2009 16:04'!
value
	^userName.! !

Object subclass: #Tutorials
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli'!

!Tutorials methodsFor: 'as yet unclassified' stamp: 'cr 6/6/2009 15:29'!
DatabaseFixture
	| semester lecture deadline user userJack userJohn group session userChr userAss1 userAss2 studentSet |
	
	session := SqsConnectionManager getInstance sessionForClass: DLUser.
	session resetDatabase.
	
	{2009. 2010. 2011} do: [:each | 
		DLSemester new
			semesterName: 'Sommer';
			year: each;
			save.
		DLSemester new
			semesterName: 'Winter';
			year: each;
			save.
	].

	semester := (SqsSearch for: DLSemester) detect: 
	[:aSemester |( aSemester semesterName = 'Sommer') & (aSemester year = 2009)].

	user := DLUser createFrom: {#userName->'Sebastian.Hillig'. #realName->'Sebastian Hillig'. #email->'Sebastian.Hillig@student.hpi.uni-potsdam.de'. #isAdmin->false}.
	userChr := DLUser createFrom: {#userName->'christian.ress'. #realName->'Christian Ress'. #email->'christian.ress@student.hpi.uni-potsdam.de'. #isAdmin->false}.
	
	userJack := DLUser createFrom: {#userName->'jack'. #realName->'Jack Johnson'. #email->'jack@hpi.uni-potsdam.de'. #isAdmin->true. #isTeacher->true.}.
	userJohn := DLUser createFrom: {#userName->'john'. #email->'john@hpi.uni-potsdam.de'. #isAdmin->false. #isAssistant->true.}.
	userAss1 := DLUser createFrom: {#userName->'assistent1'. #email->'assistent1@hpi.uni-potsdam.de'. #isAdmin->false. #isAssistant->true.}.
	userAss2 := DLUser createFrom: {#userName->'assistent2'. #email->'assistent2@hpi.uni-potsdam.de'. #isAdmin->false. #isAssistant->true.}.
	
	studentSet := Set new add: userChr; yourself.
	
	lecture := DLLecture new
		lectureName: 'Softwaretechnik I';
		lectureDescription: 'An introduction to techniques in software development';
		semester: semester;
		students: studentSet;
		save.
		
	deadline := DLDeadline createFrom: {#lecture-> lecture. #deadlineName-> 'Abgabe'. #deadlineDescription-> 'Gebt eueren Mist endlich ab'. #date->(Date today). #time->(Time now)}.

	group := DLGroup new
		groupName: 'Roundup porns';
		groupDescription: 'Roundup in awesome';
		lecture: lecture;
		users: ( {user} as: OrderedCollection );
		save.! !

!Tutorials methodsFor: 'as yet unclassified' stamp: 'sebh 6/2/2009 13:50'!
HowToResetYourDB

"session := SqsConnectionManager getInstance sessionForClass: DLUser.
session resetDatabase.
"! !

!Tutorials methodsFor: 'as yet unclassified' stamp: 'Marik 5/19/2009 17:41'!
HowToUseHPILogin

"
--> Load LDAPlayer v47 via SqueakMapPackageLoader
--> Load HPILogin class via Monticello from Repository http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/HPILogin

--> Use

hpi := HPILoginChecker new.
hpi checkLogin: 'surname.name' password: '******'"! !

!Tutorials methodsFor: 'as yet unclassified' stamp: 'sebh 6/3/2009 22:57'!
WhatToInstall
"
Von SqueakMap: Magritte 1.1.1

Announcements
MCHttpRepository
	location: 'http://source.lukas-renggli.ch/announcements'
	user: ''
	password: ''

SqsSave im Monticello updaten.

DatabaseFixture aus den Tutorials ziehen und in einem Workspace ausfhren.

Im Seaside Admin:
	Add new entry
	'deli', Application
	RootComponent DLRootTask
	SessionComponent DLSession

Benutzer aus dem fixture und mit beliebigem passwort nutzbar:
	jack - admin
	john - user
"! !

WATask subclass: #DLRootTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLRootTask class methodsFor: 'testing' stamp: 'Marik 5/26/2009 13:30'!
canBeRoot

	^true! !

!DLRootTask methodsFor: 'processing' stamp: 'MG 5/27/2009 20:35'!
go

	self loginUser.! !

!DLRootTask methodsFor: 'as yet unclassified' stamp: 'sebh 6/6/2009 16:22'!
loginUser

	| loginValidatedUser loginUser |

	loginValidatedUser := nil.
	
	[ loginValidatedUser isNil ] whileTrue: [ 
		 loginUser := self call: DLLoginUser new asComponent addValidatedForm.
		 loginValidatedUser := loginUser validateLogin.
	].
	
	self session login: loginValidatedUser.
	self call: DLRootComponent new.
		! !

!DLRootTask methodsFor: 'as yet unclassified' stamp: 'Marik 6/2/2009 16:21'!
resetOldSession

	(self session user notNil)
		ifTrue: [self session expire].! !

WATask subclass: #DLTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLTask methodsFor: 'as yet unclassified' stamp: 'sebh 6/4/2009 11:40'!
action
	"I have the same semantics like the usual go method but am called only after a permission check"
	^ self subclassResponsibility! !

!DLTask methodsFor: 'as yet unclassified' stamp: 'sebh 6/4/2009 11:40'!
go
	self permissionCheck
	ifTrue: [self action]
	ifFalse:[self call: DLPermissionDeniedComp new.].! !

!DLTask methodsFor: 'as yet unclassified' stamp: 'Marik 6/4/2009 20:58'!
permissionCheck

	^ false! !

DLTask subclass: #DLUpdateTask
	instanceVariableNames: 'updateElement callback'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLUpdateTask subclass: #DLAdminUpdateTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminUpdateTask methodsFor: 'as yet unclassified' stamp: 'Marik 6/4/2009 20:58'!
permissionCheck

	^ self session user isAdmin! !

!DLUpdateTask class methodsFor: 'as yet unclassified' stamp: 'sebh 6/4/2009 22:43'!
for: anUpdateElement
	^ self new
		updateElement: anUpdateElement;
		yourself.! !

!DLUpdateTask class methodsFor: 'as yet unclassified' stamp: 'sebh 6/4/2009 22:43'!
for: anUpdateElement withCallback: aCallback
	^ self new
		updateElement: anUpdateElement;
		callback: aCallback;
		yourself.! !

!DLUpdateTask methodsFor: 'accessing' stamp: 'sebh 6/4/2009 22:48'!
action
	self updateElement: (self call: ((self updateElement descriptionUpdate asComponentOn: self updateElement) addValidatedForm)).
	self updateElement ifNotNil: [
		self updateElement save].
	self callback
		ifNil: [self answer: true]
		ifNotNil: [self call: self callback].! !

!DLUpdateTask methodsFor: 'accessing' stamp: 'sebh 6/4/2009 22:42'!
callback
	^ callback! !

!DLUpdateTask methodsFor: 'accessing' stamp: 'sebh 6/4/2009 22:42'!
callback: anObject 
	callback := anObject! !

!DLUpdateTask methodsFor: 'accessing' stamp: 'sebh 6/4/2009 22:44'!
initialize
	super initialize.
	self callback: nil.! !

!DLUpdateTask methodsFor: 'accessing' stamp: 'sebh 6/4/2009 22:50'!
permissionCheck
	^ self session isLoggedIn.! !

!DLUpdateTask methodsFor: 'accessing' stamp: 'Marik 6/4/2009 20:51'!
updateElement

	^ updateElement! !

!DLUpdateTask methodsFor: 'accessing' stamp: 'Marik 6/4/2009 20:51'!
updateElement: anObject

	updateElement := anObject.! !

WAComponent subclass: #DLComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLComponent methodsFor: 'as yet unclassified' stamp: 'MG 6/5/2009 15:29'!
permissionCheck

	^ false.! !

!DLComponent methodsFor: 'as yet unclassified' stamp: 'MG 6/5/2009 15:29'!
renderContent: html

	self subclassResponsibility! !

!DLComponent methodsFor: 'accessing' stamp: 'MG 6/5/2009 15:29'!
renderContentOn: html

	html div with: [ html text: 'Logged in as ', self session user userName].
	self permissionCheck 
		ifTrue: [self renderContent: html.]
		ifFalse:[html div with: 'Permission denied']
	! !

DLComponent subclass: #DLDetailComp
	instanceVariableNames: 'detailElement additionalComp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLDetailComp subclass: #DLAdminDetailComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminDetailComp methodsFor: 'as yet unclassified' stamp: 'Marik 6/4/2009 21:21'!
permissionCheck

	^ self session user isAdmin! !

!DLDetailComp class methodsFor: 'as yet unclassified' stamp: 'MG 6/5/2009 15:28'!
for: anDetailElement

	^self new
		detailElement: anDetailElement;
		yourself.! !

!DLDetailComp class methodsFor: 'as yet unclassified' stamp: 'MG 6/5/2009 15:28'!
for: anDetailElement additionalComp: aComponent

	^self new
		detailElement: anDetailElement;
		additionalComp: aComponent;
		yourself.! !

!DLDetailComp methodsFor: 'accessing' stamp: 'Marik 6/4/2009 21:52'!
additionalComp

	^ additionalComp! !

!DLDetailComp methodsFor: 'accessing' stamp: 'Marik 6/4/2009 21:52'!
additionalComp: anObject

	additionalComp := anObject.! !

!DLDetailComp methodsFor: 'accessing' stamp: 'MG 6/5/2009 15:29'!
children

	^ Array with: self additionalComp! !

!DLDetailComp methodsFor: 'accessing' stamp: 'Marik 6/4/2009 21:09'!
detailElement

	^ detailElement! !

!DLDetailComp methodsFor: 'accessing' stamp: 'Marik 6/4/2009 21:09'!
detailElement: anObject

	detailElement := anObject.! !

!DLDetailComp methodsFor: 'accessing' stamp: 'Marik 6/4/2009 21:53'!
initialize

	super initialize.
	self additionalComp: nil.! !

!DLDetailComp methodsFor: 'accessing' stamp: 'Marik 6/4/2009 21:14'!
permissionCheck
	
	^ self session isLoggedIn! !

!DLDetailComp methodsFor: 'accessing' stamp: 'MG 6/5/2009 15:29'!
renderContent: html

	html definitionList with: [
		self detailElement description do: [:desc |
			html definitionTerm: desc label.
			html definitionData: (desc accessor read: (self detailElement)).
		]
	].
	html div with: self additionalComp.! !

DLComponent subclass: #DLListComp
	instanceVariableNames: 'listClass magritteReport'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLListComp subclass: #DLAdminListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/6/2009 00:13'!
permissionCheck
	^ self session user isAdmin! !

DLListComp subclass: #DLDeadlineListComp
	instanceVariableNames: 'lecture'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLDeadlineListComp class methodsFor: 'as yet unclassified' stamp: 'sebh 6/6/2009 00:27'!
for: aLecture
	^ self new
		lecture: aLecture;
		yourself.! !

!DLDeadlineListComp methodsFor: 'accessing' stamp: 'sebh 6/3/2009 21:49'!
lecture

	^ lecture! !

!DLDeadlineListComp methodsFor: 'accessing' stamp: 'sebh 6/3/2009 21:49'!
lecture: anObject

	lecture := anObject.! !

!DLDeadlineListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/6/2009 00:32'!
listClass
	^ DLDeadline! !

!DLDeadlineListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/6/2009 00:25'!
listObjects
	^ (SqsSearch for: DLDeadline) select: [:aDeadline | aDeadline lecture = self lecture]! !

!DLDeadlineListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/4/2009 22:50'!
renderContent: html
	html anchor
		callback: [self call: (DLAdminUpdateTask for: DLDeadline new)];
		text: 'Neue Deadline anlegen'.
	super renderContent: html.! !

DLListComp subclass: #DLLectureListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLLectureListComp methodsFor: 'as yet unclassified' stamp: 'cr 6/6/2009 14:56'!
userColumns
	^ {(MACommandColumn new
			addCommand: [:listElement | self call: (DLDetailComp for: listElement additionalComp: (DLDeadlineListComp for: listElement)) ]
			text: 'Details';
			yourself).
		(MACommandColumn new
			addCommand: [:listElement | listElement addStudent: self session user]
			text: 'Beitreten';
			yourself).
		}! !

!DLListComp class methodsFor: 'as yet unclassified' stamp: 'sebh 6/6/2009 00:26'!
for: aListElement
	^ self new
		listClass: aListElement;
		yourself.! !

!DLListComp methodsFor: 'accessing' stamp: 'sebh 6/6/2009 00:01'!
adminColumns
	^ {(MACommandColumn new 
			addCommand: [:listElement | self call: (DLAdminUpdateTask for: listElement)] 
			text:'Bearbeiten'; 
			yourself).}! !

!DLListComp methodsFor: 'accessing' stamp: 'MG 6/5/2009 15:26'!
children

	^ Array with: self magritteReport.! !

!DLListComp methodsFor: 'accessing' stamp: 'sebh 6/6/2009 00:05'!
columns
	self session user isAdmin 
		ifTrue: [^ self adminColumns, self userColumns]
		ifFalse:[^ self userColumns].
	! !

!DLListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/6/2009 00:28'!
initializeReport
	self magritteReport: (MAReport rows: self listObjects
							 	  description: (self listClass) new descriptionList).
	self columns do: [:each | self magritteReport addColumn: each].! !

!DLListComp methodsFor: 'accessing' stamp: 'MG 6/5/2009 15:33'!
listClass

	^ listClass! !

!DLListComp methodsFor: 'accessing' stamp: 'MG 6/5/2009 15:33'!
listClass: anObject

	listClass := anObject.! !

!DLListComp methodsFor: 'accessing' stamp: 'sebh 6/6/2009 00:24'!
listObjects
	^ (SqsSearch for: self listClass) findAll.! !

!DLListComp methodsFor: 'accessing' stamp: 'MG 6/5/2009 15:31'!
magritteReport
	"Lazily initialize report"
	
	magritteReport ifNil: [self initializeReport].
	^ magritteReport! !

!DLListComp methodsFor: 'accessing' stamp: 'MG 6/5/2009 15:23'!
magritteReport: anObject

	magritteReport := anObject.! !

!DLListComp methodsFor: 'accessing' stamp: 'MG 6/5/2009 15:26'!
permissionCheck

	^ self session isLoggedIn.! !

!DLListComp methodsFor: 'accessing' stamp: 'MG 6/5/2009 15:40'!
renderContent: html

	html div with: self magritteReport.! !

!DLListComp methodsFor: 'accessing' stamp: 'sebh 6/6/2009 00:08'!
userColumns
	^ {(MACommandColumn new
			addCommand: [:listElement | self call: (DLDetailComp for: listElement)]
			text: 'Details';
			yourself).}! !

DLComponent subclass: #DLPermissionDeniedComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLPermissionDeniedComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/3/2009 17:02'!
permissionCheck
	"Always allow anyone to see permission denied"
	^ true! !

!DLPermissionDeniedComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/3/2009 17:24'!
renderContent: html
	html heading: 'Permission denied';
		  paragraph: 'You have insufficient rights to open this page.'! !

WAComponent subclass: #DLMenuComp
	instanceVariableNames: 'entries content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLMenuComp subclass: #DLAdminMenuComp
	instanceVariableNames: 'lectureListComp formComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminMenuComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/6/2009 00:11'!
addEntries
	self entries
		add: 'Lehrveranstaltungen' -> {
					 'Neue Lehrveranstaltung anlegen' ->
							[self showComponent: (DLAdminUpdateTask for: DLLecture new withCallback: (DLListComp for: DLLecture))].
					'Alle Lehrveranstaltungen' -> 
							[self showComponent: (DLLectureListComp for: DLLecture)].
					'Alle Benutzer' -> 
							[self showComponent: (DLAdminListComp for: DLUser)].
		};
		add: 'Andere Aktionen' -> { 'Ausloggen' -> [] }.! !

!DLMenuComp methodsFor: 'as yet unclassified' stamp: 'sebh 5/27/2009 15:27'!
addEntries
	"If an inheriting method has defined this method, we use it to automagically insert entries"! !

!DLMenuComp methodsFor: 'as yet unclassified' stamp: 'sebh 5/26/2009 17:12'!
addEntry: aString withAction: aBlock
	
	^ self entries add: aString -> aBlock! !

!DLMenuComp methodsFor: 'accessing' stamp: 'sebh 5/26/2009 17:08'!
entries

	^ entries! !

!DLMenuComp methodsFor: 'accessing' stamp: 'sebh 5/26/2009 17:08'!
entries: anObject

	entries := anObject.! !

!DLMenuComp methodsFor: 'as yet unclassified' stamp: 'sebh 5/27/2009 15:26'!
initialize
	super initialize.
	self entries: OrderedCollection new.
	self addEntries.! !

!DLMenuComp methodsFor: 'as yet unclassified' stamp: 'sebh 5/27/2009 15:42'!
renderContentOn: html

	self entries
		do: [:entry | self renderEntry: entry on: html. ]
		separatedBy: [html break].! !

!DLMenuComp methodsFor: 'as yet unclassified' stamp: 'sebh 5/27/2009 15:50'!
renderEntry: anEntry on: html
	self renderEntry: anEntry on: html level: 2 ! !

!DLMenuComp methodsFor: 'as yet unclassified' stamp: 'sebh 5/28/2009 12:45'!
renderEntry: anEntry on: html level: aLevel
	anEntry value isCollection
	ifTrue: [ 
		html heading: anEntry key level: aLevel.
		anEntry value do: [:entry | self renderEntry: entry on: html level: aLevel+1] separatedBy: [html break].
	]
	ifFalse: [
		html anchor
			callback: anEntry value;
			with: anEntry key.
	].! !

!DLMenuComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/3/2009 17:58'!
showComponent: aComponent
	self session announcer announce: ((self signal) forComponent: aComponent)! !

!DLMenuComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/3/2009 17:55'!
signal
	^ DLViewCompReplacement! !

WAComponent subclass: #DLRootComponent
	instanceVariableNames: 'menuComp viewComp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLRootComponent methodsFor: 'as yet unclassified' stamp: 'sebh 6/3/2009 12:00'!
children
	^ Array with: self viewComp with: self menuComp! !

!DLRootComponent methodsFor: 'as yet unclassified' stamp: 'sebh 6/3/2009 17:58'!
initialize
	super initialize.
	self menuComp: DLAdminMenuComp new.
	self session announcer on: DLViewCompReplacement do: [:announcement | self viewComp: announcement component ]! !

!DLRootComponent methodsFor: 'accessing' stamp: 'sebh 6/3/2009 12:10'!
menuComp

	^ menuComp! !

!DLRootComponent methodsFor: 'accessing' stamp: 'sebh 6/3/2009 12:10'!
menuComp: anObject

	menuComp := anObject.! !

!DLRootComponent methodsFor: 'as yet unclassified' stamp: 'sebh 6/3/2009 12:10'!
renderContentOn: html
	html div class:'menu'; with: self menuComp.
	html div class:'content'; with: self viewComp.! !

!DLRootComponent methodsFor: 'accessing' stamp: 'sebh 6/3/2009 12:10'!
viewComp

	^ viewComp! !

!DLRootComponent methodsFor: 'accessing' stamp: 'sebh 6/3/2009 12:10'!
viewComp: anObject

	viewComp := anObject.! !

SqsSearchInterface subclass: #DLUpdateModel
	instanceVariableNames: 'created updated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLUpdateModel class methodsFor: 'persistence-description' stamp: ''!
sqsDescrCreated
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'created';
		 sqlType: #dateAndTime;
		 objectClass: #DateAndTime;
		 tableName: 'dl_update_models';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'created';
		 yourself! !

!DLUpdateModel class methodsFor: 'persistence-description' stamp: ''!
sqsDescrUpdated
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'updated';
		 sqlType: #dateAndTime;
		 objectClass: #DateAndTime;
		 tableName: 'dl_update_models';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'updated';
		 yourself! !

!DLUpdateModel methodsFor: 'accessing' stamp: 'sebh 5/20/2009 19:03'!
created

	^ created! !

!DLUpdateModel methodsFor: 'accessing' stamp: 'sebh 5/20/2009 19:03'!
created: anObject

	created := anObject.! !

!DLUpdateModel methodsFor: 'accessing' stamp: 'sebh 5/20/2009 19:06'!
initialize
	self created: DateAndTime now.! !

!DLUpdateModel methodsFor: 'as yet unclassified' stamp: 'sebh 5/20/2009 19:06'!
save
	self updated: DateAndTime now.
	super save! !

!DLUpdateModel methodsFor: 'accessing' stamp: 'sebh 5/20/2009 19:03'!
updated

	^ updated! !

!DLUpdateModel methodsFor: 'accessing' stamp: 'sebh 5/20/2009 19:03'!
updated: anObject

	updated := anObject.! !

WASession subclass: #DLSession
	instanceVariableNames: 'user announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLSession methodsFor: 'accessing' stamp: 'sebh 6/3/2009 12:04'!
announcer
	^ announcer ifNil: [ announcer := Announcer new. ].! !

!DLSession methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:03'!
charSet
	^ 'iso-8859-1'! !

!DLSession methodsFor: 'computing' stamp: 'Marik 5/20/2009 17:09'!
isLoggedIn

	^self user isNil not! !

!DLSession methodsFor: 'computing' stamp: 'Marik 5/20/2009 17:09'!
login: aUser

	self user: aUser! !

!DLSession methodsFor: 'computing' stamp: 'Marik 5/20/2009 17:09'!
logout

	self user: nil.! !

!DLSession methodsFor: 'accessing' stamp: 'Marik 5/20/2009 17:08'!
user

	^ user! !

!DLSession methodsFor: 'accessing' stamp: 'Marik 5/20/2009 17:08'!
user: anObject

	user := anObject.! !

Announcement subclass: #DLViewCompReplacement
	instanceVariableNames: 'component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLViewCompReplacement class methodsFor: 'as yet unclassified' stamp: 'sebh 6/3/2009 17:57'!
forComponent: aComponent
	^ self new
		component: aComponent;
		yourself.! !

!DLViewCompReplacement methodsFor: 'accessing' stamp: 'sebh 6/3/2009 17:55'!
component

	^ component! !

!DLViewCompReplacement methodsFor: 'accessing' stamp: 'sebh 6/3/2009 17:55'!
component: anObject

	component := anObject.! !

SqsConfig subclass: #DeliSqsConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-configuration'!

!DeliSqsConfig class methodsFor: 'as yet unclassified' stamp: 'sebh 5/20/2009 16:13'!
connectionSpecification
	^ SqsMySQLConnectionSpecification 
		user: 'deli'
		password: ''
		database: 'deli'
		port: 3306
		host: 'localhost'! !
